#-----------------------------------------------------------------------------
#
#   HXFS 2019 - Vector algebra
#
#-----------------------------------------------------------------------------

from math import sin, cos

class Rotation(object):

    def __init__(self, a):
        self.c = cos(a)
        self.s = sin(a)
    
    def __mul__(self, v):
        x, y = v
        c = self.c
        s = self.s
        return c * x - s * y, s * x + c * y

def cross(u, v):
    return u[0] * v[1] - u[1] * v[0]

def point_in_polygon(p, vertices):
    n = len(vertices)
    x, y = p
    x0, y0 = vertices[-1]
    for x1, y1 in vertices:
        v1 = x1 - x0, y1 - y0
        v2 = x - x0, y - y0
        if cross(v1, v2) < 0:
            return False
        x0, y0 = x1, y1
    return True
